#!/bin/bash
. common.bash

PATH_INFO=`echo $PATH_INFO | sed -r 's,^/+,,; s,/+$,,'`

if [[ -z $PATH_INFO || `echo $PATH_INFO | grep -v -E -s '^[a-zA-Z0-9_/]+$'`  \
	|| `echo $PATH_INFO | grep -v -E -s '[a-zA-Z0-9]'` ]]; then
	echo "File name does not meet syntax standards."
	exit 0
fi

if [[ -d $DIRIDIR/$PATH_INFO ]]; then
	echo "File is a directory"
	exit 0
fi

title="`basename $PATH_INFO | sed 's/_/ /g'`"
cat <<END
Cache-Control: no-cache
Content-Type: text/html

<!DOCTYPE HTML SYSTEM>
<html>
	<head>
		<title>$title</title>
		<meta http-equiv="cache-control" content="no-cache">
		<meta http-equiv="pragma" content="no-cache"> 
		<meta name="author" content="Unknown">
		<meta name="searchtitle" content="dwm wmii suck less">
		<meta name="keywords" content="x11 dwm wmi wmii dmenu slock suck less window manager xlib">
		<meta name="description" content="dynamic window manager improved 2">
		<meta name="revisit-after" content="2 days">
		<meta name="audience" content="all">
		<meta name="content-language" content="en">
		<meta name="copyright" content="(C)opyright 2006-2007 by Anselm R. Garbe">
		<meta name="robots" content="index,follow">
		<style type="text/css">
					body { background-color: #444; color: #ddd; font-family: sans-serif; height: 100%; margin: 0px; width: 100%; }
			img { border: 0px; /* top right bottom left */ }
			a { color: #9cf; }
			div#slogan { background-color: #222; border: 0px; padding: 5px 0 5px 1%; }
			div#error { background-color: #444; border: 1px solid #555; color: #f00; padding: .2em .5em .2em .5em; margin-top: 1em; }
			div#error:before { content: "Error: "; color: white; font-weight: bold; }
			div#error + H1 { margin-top: .25em }
			div#ctrlmenu { background-color: #222; border: 0px; position: absolute; top: 0; right: 0; padding: 5px 1% 5px 0px; text-align: right; }
			#ctrlmenu ul { list-style: none; margin: 0; padding: 0px; }
			#ctrlmenu li { display: inline; }
			#ctrlmenu a { color: #9cf; padding: 5px; text-decoration: none; }
			#ctrlmenu a:hover { background-color: #333; padding: 5px; text-decoration: none; }
			div#menu { border: 0px; float: left; font-size: 95%; min-height: 100%; padding: 0%; width: 25%; }
			#menu ul { padding: 5px 5px 5px 1.5em; }
			#menu li { list-style: none; padding: 6px; }
			#menu a { color: #ddd; padding: 4px; text-decoration: none; }
			#menu a:hover { background-color: #555; padding: 4px; text-decoration: none; }
			#menu a.current { color: #fff; padding: 4px; text-decoration: none; }
			div#page { background-color: #333; border: 0px; float: left; min-height: 100%; padding: 2%; width: 71%; }
			div#preview { background-color: #444; border: 1px solid #555; color: #eee; padding: 2%; width: 71%; margin-bottom: .7em; }
			div#page :first-child, div#content :first-child, div#preview :first-child { margin-top: 0px; }
			div#editor{ background-color: #333; border: 0px; color: #ddd; padding: 2%; width: 96%; }
			div#bot, div#bar { background-color: #222; border: 0px; clear: both; padding: 5px 1% 5px 0px; text-align: right; width: 99%; }
			textarea { background-color: #444; border: 1px solid #555; color: #eee; width: 100%; }
			input { background-color: #444; border: 1px solid #555; color: #eee; }
		</style>
	</head>
	<body>
		<div id="slogan">
			<i>$SLOGAN</i>
		</div>
		<div id="editor">
			<h1>
END
echo $title
cat <<END
</h1>
<p><small>
END
echo "<i>($PATH_INFO)</i>"
cat <<END
<br>
<a href="$ADDRESS/$SHOW/$PATH_INFO">show</a>
<a href="$ADDRESS/$REMOVE/$PATH_INFO">remove</a>
</small></p>
			<form action="$ADDRESS/$SAVE/$PATH_INFO" method="post">
				<textarea name='text' id='text' cols='80' rows='43'>
END
if [ -f "$DIRIDIR/$PATH_INFO.diri" ]; then
	cat "$DIRIDIR/$PATH_INFO.diri"
fi
cat <<END
</textarea>
				<p><small>
				diri documents are written using <a href="http://daringfireball.net/projects/markdown/syntax">Markdown syntax</a>.
				</small></p>
				<p align="right">
					<b>Password:</b> <input type='password' name='password' size='20'/>
					<input type='submit' value='Save'/><br />
				</p>
			</form>
		</div>
		<div id="bot">
			<small>&copy Copyright 2007 Anselm R. Garbe <a href="http://www.suckless.org/~arg/">Impressum</a></small>
		</div>
	</body>
</html>
END

