#!/bin/bash
. common.bash

	
PATH_INFO=`echo $PATH_INFO | sed -r 's,^/+,,; s,/+$,,'`
dirs="`echo $PATH_INFO | sed -r 's,[a-zA-Z0-9_]+$,,'`"

if [[ -z $PATH_INFO  || `echo $PATH_INFO | grep -v -E -s '^[a-zA-Z0-9_/]+$'` ]]; then
	echo "File name does not meet syntax standards."
	exit 0
fi

if [[ -d $DIRIDIR/$PATH_INFO ]]; then
	echo "File is a directory"
	#redirect
	exit 0
fi

setvars 

if [[ -n $password ]]; then
	password="`echo -n $password | $HASHCMD`"
else
	redirect $EDIT/$PATH_INFO
fi

if [[ -z $text ]]; then
	redirect $EDIT/$PATH_INFO
fi

oldifs="$IFS"
IFS="
"
for item in $HASHPASS; do
	if [[ "$item" == "$password" ]]; then
		passvalid=true
	fi
done
if [[ "$passvalid" != "true" ]]; then
	redirect $EDIT/$PATH_INFO
fi
IFS="$oldifs"

if [[ -z $text ]]; then
	redirect $EDIT/$PATH_INFO
fi

if [[ ! -d $DIRIDIR/$dirs ]]; then
	mkdir -p $DIRIDIR/$dirs
	if [[ ! -d $DIRIDIR/$dirs ]]; then
		echo "Could not create path for file"
		exit 0
	fi
fi

if [[ ! -d $BACKUPDIR/$dirs ]]; then
	mkdir -p $BACKUPDIR/$dirs
	if [[ ! -d $BACKUPDIR/$dirs ]]; then
		echo "Could not create path for backups"
		exit 0
	fi
fi

echo $text | $URLDECODE > $DIRIDIR/$PATH_INFO.diri
cp $DIRIDIR/$PATH_INFO.diri $BACKUPDIR/$PATH_INFO."`date +%Y%m%d%H%M%S`"
$WIKIFMT < $DIRIDIR/$PATH_INFO.diri > $DIRIDIR/$PATH_INFO
redirect $SHOW/$PATH_INFO
