#!/bin/bash
. common.bash

# makes the menu
function menu {
	START_LOC="$1"	# Directory to start from
	SELE_FILE="$2"	# Selected File

	cd $START_LOC
	echo "<ul>"
	# for all regular files and directories in the PWD
	for index in `ls -F . | awk '/^([a-zA-Z0-9_]+[\/*]?)+$/' | sed 's,/$,,'`; do
		# full path from START_LOC to index
		full_path="`echo "$3/$index" | sed 's,^/,,'`"
		bname="`echo $index | sed 's/_/ /g'`"
		if [[ -d $bname ]]; then
			bname="$bname/"
		fi
		# fix: space & spaceracer problem 
		# if the file is in the selected path
		#if [[ `awk 'BEGIN { print index("'$SELE_FILE'", "'$full_path'") }'` == 1 ]] \
		#		&& [[ "`basename $SELE_FILE`" == "$index" || \
		#		`awk 'BEGIN { print index("'$SELE_FILE'", "'$full_path/'") }'` == 1 ]]; then
		if [ `echo $SELE_FILE | grep -E "^$full_path"` ]; then
			echo "<li><a href=\"$ADDRESS/$SHOW/$full_path\" class=\"current\"> $bname</a>"  

			# if directory, recurse
			if [[ -d $index ]]; then
				menu $index $SELE_FILE $full_path | awk '{print "\t" $0}'
			fi
		else
			echo "<li><a href=\"$ADDRESS/$SHOW/$full_path\"> $bname </a>"
		fi
	done
	echo "</ul"
}

# remove the '/' at the beginning and end
PATH_INFO=`echo $PATH_INFO | sed -r 's,^/+,,; s,/+$,,'`

# if PATH_INFO has characters other than [a-zA-Z0-9_/]
if [[ `echo $PATH_INFO | grep -v -E -s '^[a-zA-Z0-9_/]+$'` ]]; then
	echo "File name does not meet syntax standards."
	exit 0
fi

# If $PATH_INFO is a directory, make it point to the first item in the dir
if [[ -d $DIRIDIR/$PATH_INFO ]]; then
	file="`find $DIRIDIR/$PATH_INFO -type f | grep -E '/[a-zA-Z0-9_]+$' | sort | sed 1q`"
	if [[ $file && -f $file ]]; then
		PATH_INFO="`echo $file | sed -r 's,'^$DIRIDIR'/,,'`"
	fi
fi

# HTML title
title="`basename "$PATH_INFO" | sed 's/_/ /g'`"

# Actual html
cat <<END
Cache-Control: no-cache
Content-Type: text/html

<!DOCTYPE HTML SYSTEM>
<html>
	<head>
		<title>$title</title>
		<meta http-equiv="cache-control" content="no-cache">
		<meta http-equiv="pragma" content="no-cache"> 
		<meta name="author" content="Unknown">
		<meta name="searchtitle" content="dwm wmii suck less">
		<meta name="keywords" content="x11 dwm wmi wmii dmenu slock suck less window manager xlib">
		<meta name="description" content="dynamic window manager improved 2">
		<meta name="revisit-after" content="2 days">
		<meta name="audience" content="all">
		<meta name="content-language" content="en">
		<meta name="copyright" content="(C)opyright 2006-2007 by Anselm R. Garbe">
		<meta name="robots" content="index,follow">
		<style type="text/css">
			body { background-color: #444; color: #ddd; font-family: sans-serif; height: 100%; margin: 0px; width: 100%; }
			img { border: 0px; /* top right bottom left */ }
			a { color: #9cf; }
			div#slogan { background-color: #222; border: 0px; float: left; padding: 5px 1% 5px 1%; width: 68%; }
			div#ctrlmenu { background-color: #222; border: 0px; float: left; padding: 5px 1% 5px 0px; text-align: right; width: 29%; }
			#ctrlmenu ul { list-style: none; margin: 0; padding: 0px; }
			#ctrlmenu li { display: inline; }
			#ctrlmenu a { color: #9cf; padding: 5px; text-decoration: none; }
			#ctrlmenu a:hover { background-color: #333; padding: 5px; text-decoration: none; }
			div#menu { border: 0px; float: left; font-size: 95%; min-height: 100%; padding: 0%; width: 25%; }
			#menu ul { padding: 5px 5px 5px 1.5em; }
			#menu li { list-style: none; padding: 6px; }
			#menu a { color: #ddd; padding: 4px; text-decoration: none; }
			#menu a:hover { background-color: #555; padding: 4px; text-decoration: none; }
			#menu a.current { color: #fff; padding: 4px; text-decoration: none; }
			div#page { background-color: #333; border: 0px; float: left; min-height: 100%; padding: 2%; width: 71%; }

			div#bot { background-color: #222; border: 0px; clear: both; padding: 5px 1% 5px 0px; text-align: right; width: 99%; }
		</style>
	</head>
	<body>
		<div id="slogan">
			<i>$SLOGAN</i>
		</div>
		<div id="ctrlmenu">
			<ul>
				<li><a href="$ADDRESS/$EDIT/$PATH_INFO">edit</a></li>
				<li><a href="$ADDRESS/$REMOVE/$PATH_INFO">remove</a></li>
			</ul>
		</div>
		<div style='clear: both; padding: 0px;'></div>
		<div id="menu">
END
menu $DIRIDIR $PATH_INFO
cat <<END
		</div>
		<div id="page">
			<div id="content" style="max-width: 60em;">
END
if [ -f "$DIRIDIR/$PATH_INFO" ]; then
	cat "$DIRIDIR/$PATH_INFO"
fi
cat <<END
			</div>
		</div>
		<div id="bot">
			<small>&copy Copyright 2007 Anselm R. Garbe <a href="http://www.suckless.org/~arg/">Impressum</a></small>
		</div>
	</body>
</html>
END
